package net.greenfieldtech.cloudonixsdk.cloudonixdialer.activities;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.provider.ContactsContract;
import android.support.design.widget.Snackbar;
import android.text.TextUtils;
import android.widget.LinearLayout;
import android.widget.TextView;
import butterknife.BindView;
import butterknife.OnClick;
import net.greenfieldtech.cloudonixsdk.appinterface.VoipCall;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.R;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.utils.SdkFacade;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.utils.VoIPClient;

/**
 * Created by alex on 05.05.16.
 */

public class ContactInfoActivity extends BaseActivity {

  public static final String CONTACT_NAME = "CONTACT_NAME";
  public static final String CONTACT_NUMBER = "CONTACT_NUMBER";

  @BindView(R.id.root)
  LinearLayout root;
  @BindView(R.id.tv_contact_name)
  TextView tvContactName;
  @BindView(R.id.tv_number)
  TextView tvNumber;

  private String contactName;
  private String contactNumber;

  @Override
  protected int getLayoutResource() {
    return R.layout.activity_contact_info;
  }

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    enableBackButton();
    setTitle("Contact info");

    contactName = getIntent().getStringExtra(CONTACT_NAME);
    contactNumber = getIntent().getStringExtra(CONTACT_NUMBER);

    tvContactName.setText(contactName);
    tvNumber.setText(contactNumber);
  }

  @OnClick(R.id.iv_call)
  void call() {
    if (!SdkFacade.isCodecSelected()) {
      Snackbar.make(root, getString(R.string.keypad_error_no_codec), Snackbar.LENGTH_SHORT).show();
      return;
    }
    if (!TextUtils.isEmpty(contactNumber)) {
      VoIPClient client = VoIPClient.getInstance();
      if (client.isRegistered()) {
        client.dial(contactNumber);
        doCAll();
      } else {
        Snackbar.make(root, getString(R.string.activity_call_not_registered), Snackbar.LENGTH_SHORT)
            .show();
      }
    } else {
      Snackbar.make(root, getString(R.string.contacts_error_invalid_number), Snackbar.LENGTH_SHORT)
          .show();
    }
  }

  @OnClick(R.id.action_add_contact)
  void addContact() {
    Intent intent = new Intent(Intent.ACTION_INSERT, ContactsContract.Contacts.CONTENT_URI);
    startActivity(intent);
  }

  @OnClick(R.id.action_add_to_existing)
  void addToExisting() {

  }

  // TODO remove it. It's a bad idea !!!
  private void doCAll() {
    new Handler().postDelayed(new Runnable() {
      @Override
      public void run() {
        runOnUiThread(new Runnable() {
          @Override
          public void run() {
            VoIPClient client = VoIPClient.getInstance();
            VoipCall[] calls = client.getCalls();
            if (calls != null && calls.length != 0) {
              Intent intent = new Intent(ContactInfoActivity.this, OutgoingCallActivity.class);
              intent.putExtra(OutgoingCallActivity.CALL_ID, client.getCalls()[0].key);
              intent.putExtra(OutgoingCallActivity.CALL_NUMBER, client.getCalls()[0].url);
              startActivity(intent);
            }
          }
        });
      }
    }, 1500);
  }

}
