package net.greenfieldtech.cloudonixsdk.cloudonixdialer.dialogs;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.Dialog;
import android.os.Build;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import net.greenfieldtech.cloudonixsdk.cloudonixdialer.R;

/**
 * Created by arikhalperin on 22/05/2016.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class AddCallDialog extends DialogFragment {

  private View mDialogView;
  private AddCallDialogListener mListener;

  @Override
  public void onAttach(Activity activity) {
    super.onAttach(activity);
    // Verify that the host activity implements the callback interface
    try {
      // Instantiate the NoticeDialogListener so we can send events to the host
      mListener = (AddCallDialogListener) activity;
    } catch (ClassCastException e) {
      // The activity doesn't implement the interface, throw exception
      throw new ClassCastException(activity.toString()
          + " must implement NoticeDialogListener");
    }
  }

  @Override
  public Dialog onCreateDialog(Bundle savedInstanceState) {
    AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
    // Get the layout inflater
    LayoutInflater inflater = getActivity().getLayoutInflater();

    // Inflate and set the layout for the dialog
    // Pass null as the parent view because its going in the dialog layout
    mDialogView = inflater.inflate(R.layout.add_number_layout, null);

    mDialogView.findViewById(R.id.buttonOK).setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        EditText et = (EditText) mDialogView.findViewById(R.id.editText);
        mListener.setNumber(et.getText().toString());
        dismiss();
      }
    });

    mDialogView.findViewById(R.id.buttonCancel).setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        dismiss();
      }
    });

    builder.setView(mDialogView);
    return builder.create();
  }

}